Attribute VB_Name = "Module1"
Option Explicit

Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private m_TimerID As Long
Private m_Running As Boolean
Private Sub Main()
    ' Start the timer.
    m_TimerID = SetTimer(0, 0, 3000, _
        AddressOf MyTimer)

    ' Run until the timer sets m_Running to False.
    m_Running = True
    Do While m_Running
        ' Pause a little while so we don't hog the CPU.
        Sleep 200
        DoEvents
    Loop

    ' Stop the timer.
    KillTimer 0, m_TimerID
End Sub
' See if the user wants to stop.
Public Sub MyTimer(hwnd As Long, msg As Long, idTimer As Long, dwTime As Long)
Static i As Integer
Static messagebox_visible As Boolean

    ' Do nothing if another timer event is currently
    ' displaying the message box.
    If messagebox_visible Then Exit Sub

    messagebox_visible = True
    i = i + 1
    If MsgBox(i & ": Stop?", vbYesNo) = vbYes Then m_Running = False
    messagebox_visible = False
End Sub
